ansible: Install gcc-riscv64-linux-gnu on Debian-based distros
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
51c9c62d 1#!/bin/bash
f3d8604b 2#
51c9c62d 3# Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
51c9c62d
MJ
18set -exu
19
39961776 20# Parameters
2456f978 21arch=${arch:-amd64}
39961776
MJ
22cross_arch=${cross_arch:-}
23ktag=${ktag:-}
5a196804
MJ
24kgitrepo=${kgitrepo:-}
25mversion=${mversion:-}
26mgitrepo=${mgitrepo:-}
39961776
MJ
27
28
339db64d
MJ
29## FUNCTIONS ##
30
f3d8604b
MJ
31# Kernel version compare functions
32verlte() {
51fa2ab3 33 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
34}
35
36verlt() {
28b10e79 37 # shellcheck disable=SC2015
51fa2ab3 38 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
39}
40
41vergte() {
51fa2ab3 42 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
43}
44
45vergt() {
28b10e79 46 # shellcheck disable=SC2015
51fa2ab3 47 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
48}
49
339db64d 50
5a196804
MJ
51git_clone_modules_sources() {
52 mkdir -p "$MODULES_GIT_DIR"
28b10e79
MJ
53
54 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
55 # as a branch name.
56 if [ "${mversion:0:5}" = "refs/" ]; then
57 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
58 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
59 else
60 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
61 fi
5a196804
MJ
62}
63
64# Checkout a shallow kernel tree of the specified tag
65git_clone_linux_sources() {
66 mkdir -p "$LINUX_GIT_DIR"
67 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
68}
7e02032c 69
7e02032c 70
5a196804
MJ
71# Export the kernel sources from the git repo
72git_export_linux_sources() {
73 cd "$LINUX_GIT_DIR"
74 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
75}
76
77
78# Upload the tar archive to the object store
79upload_archive_obj() {
80 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
81 rm -f "$WORKSPACE/$obj_name"
82}
83
84
85extract_archive_obj() {
86 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
87 rm -f "$WORKSPACE/$obj_name"
88}
89
90
91tar_archive_obj() {
92 cd "$LINUX_OBJ_DIR"
93 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
94 cd -
95}
96
6c0b2710
KS
97list_gccs() {
98 local gccs
99 gccs=()
100 IFS=: read -r -a path_array <<< "$PATH"
101 while read -r gcc ; do
102 gccs+=("$gcc")
103 done < <(find "${path_array[@]}" -maxdepth 1 -regex '.*/gcc-[0-9\.]+$' -printf '%f\n' | sort -t- -k2 -V -r)
104 echo "${gccs[@]}"
105}
106
5a196804
MJ
107# Find the most recent GCC version supported by the kernel sources
108select_compiler() {
109 local selected_cc
110
111 cd "$LINUX_SRCOBJ_DIR"
112
113 kversion=$(make -s kernelversion)
114
115 set +e
116
6c0b2710 117 for cc in $(list_gccs) ; do
5a196804
MJ
118 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
119 selected_cc="$cc"
120 break
121 fi
122 done
123
124 set -e
125
126 if [ "x$selected_cc" = "x" ]; then
127 echo "Found no suitable compiler."
128 exit 1
129 fi
130
1d5a0a3c
MJ
131 # Force gcc-4.8 for kernels before 3.18
132 if { verlt "$kversion" "3.18"; }; then
23db2292 133 selected_cc=gcc-4.8
7e02032c
MJ
134 fi
135
425e4992
MJ
136 if [ "$selected_cc" != "gcc-4.8" ]; then
137 # Older kernel Makefiles do not expect the compiler to default to PIE
138 KAFLAGS="-fno-pie"
c45b04df 139 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
140 KCPPFLAGS="-fno-pie"
141 export KAFLAGS KCFLAGS KCPPFLAGS
142 fi
143
5a196804 144 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 145 export HOSTCC="${selected_cc}"
5a196804
MJ
146
147 cd -
148}
149
150
151build_linux_kernel() {
152 cd "$LINUX_SRCOBJ_DIR"
153
154 kversion=$(make -s kernelversion)
155
7e02032c 156 # Generate kernel configuration
a1ae361e 157 case "$ktag" in
7e02032c 158 Ubuntu*)
39961776 159 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 160 if vergte "${kversion}" "4.10"; then
39961776
MJ
161 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
162 exit 0
163 fi
164 fi
af101606
MJ
165
166 # Disable riscv64 config generation, we don't have a toolchain on bionic
167 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
168
073dc82c
MJ
169 # Hack for kernel Ubuntu-hwe-5.8
170 if [ ! -f "debian/compat" ]; then
171 echo "10" > "debian/compat"
172 fi
173
a46abb0a
MJ
174 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
175 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 176 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 177 ;;
c45b04df 178
7e02032c 179 *)
16844a6d
MJ
180 # Force 32bit build on i386, default is 64bit
181 if [ "$arch" = "i386" ]; then
5a196804
MJ
182 export ARCH="i386"
183 fi
184
185 # allyesconfig is mostly broken for kernels of the 2.6 series
186 if verlt "$kversion" "3.0"; then
187 vanilla_config="defconfig"
7a76a4d0
MJ
188 fi
189
5a196804 190 make "${vanilla_config}"
7e02032c
MJ
191 ;;
192 esac
193
53b51a15 194 # oldnoconfig was renamed in 4.19
5a196804 195 if vergte "$kversion" "4.19"; then
53b51a15 196 update_conf_target="olddefconfig"
5a196804 197 else
53b51a15 198 update_conf_target="oldnoconfig"
5a196804
MJ
199 fi
200
201 # Fix 'defined(@array)' was removed from recent perl
202 if [ -f "kernel/timeconst.pl" ]; then
203 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
204 fi
205
206 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 207 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
208 if [ -f "arch/x86/kvm/svm.c" ]; then
209 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
210 fi
211
212 if [ -f "arch/x86/kvm/vmx.c" ]; then
213 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
214 fi
215 fi
216
53b51a15
MJ
217 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
218 # Convert them to 'cmpw' which was previously done silently
219 if verlt "$kversion" "4.9"; then
220 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
221 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
222 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
223 fi
224
5a196804
MJ
225 # Fix a typo in v2.6.36.x
226 if [ -f "arch/x86/kernel/entry_64.S" ]; then
227 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
228 fi
229
53b51a15
MJ
230 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
231 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
232 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
233 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
234 fi
235
5a196804
MJ
236 # Fix kernel < 3.0 with gcc >= 4.7
237 if verlt "$kversion" "3.0"; then
238 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
239 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
240 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
241 echo "header-y += linkage.h" >> include/linux/Kbuild
242 fi
243
7e02032c 244 # GCC 4.8
53b51a15
MJ
245 if [ "$HOSTCC" == "gcc-4.8" ]; then
246 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
247 fi
7e02032c
MJ
248
249 # Don't try to sign modules
53b51a15 250 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 251
9ef18fa2 252 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 253 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
254
255 # Cause problems with inline assembly on i386
53b51a15 256 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 257
1d5a0a3c 258 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
259 scripts/config --disable CONFIG_SAMPLES
260 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
261
262 # Disable kcov
53b51a15 263 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
264
265 # Broken on some RT kernels
53b51a15 266 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 267
1e300ea9 268 # Broken drivers
53b51a15
MJ
269 scripts/config --disable CONFIG_RAPIDIO_TSI721
270 scripts/config --disable CONFIG_SGI_XP
271 scripts/config --disable CONFIG_MFD_WM8994
272 scripts/config --disable CONFIG_DRM_RADEON
273 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 274
5a196804
MJ
275 # IGBVF won't build with recent gcc on 2.6.38.x
276 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 277 scripts/config --disable CONFIG_IGBVF
5a196804 278 fi
9ef18fa2 279
c72041eb
MJ
280 # Don't fail the build on warnings
281 scripts/config --disable CONFIG_WERROR
282
51fa2ab3 283 # Set required options
53b51a15
MJ
284 scripts/config --enable CONFIG_TRACEPOINTS
285 scripts/config --enable CONFIG_KALLSYMS
286 scripts/config --enable CONFIG_HIGH_RES_TIMERS
287 scripts/config --enable CONFIG_KPROBES
288 scripts/config --enable CONFIG_FTRACE
289 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
290 scripts/config --enable CONFIG_KALLSYMS_ALL
291 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
292 scripts/config --enable CONFIG_PERF_EVENTS
293 scripts/config --enable CONFIG_EVENT_TRACING
294 scripts/config --enable CONFIG_KRETPROBES
7e02032c 295
1d28ffce
MJ
296 # FIXME: disable objtool on vmlinux, it OOMs on allyesconfig
297 sed -i 's/objtool_link vmlinux.o//' scripts/link-vmlinux.sh || true
81e61c58
MJ
298 # Starting with v6.1-rc6
299 sed -i 's/^objtool-enabled := .*/objtool-enabled := /' scripts/Makefile.vmlinux_o || true
1d28ffce 300
ba1a68bc
MJ
301 # Disable SORTTAB
302 sed -i 's/is_enabled CONFIG_BUILDTIME_TABLE_SORT/is_enabled CONFIG_NONEXISTANT/' scripts/link-vmlinux.sh || true
303
7a76a4d0 304 # Debug
5a196804
MJ
305 #cat .config
306
307 make "$update_conf_target" CC="$CC"
308 make -j"$NPROC" CC="$CC"
309
c45b04df 310 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
311
312 # Save the kernel and modules
313 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15 314 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
f4c112e8 315 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
316 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
317 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
318 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
319}
320
321
322extract_distro_headers() {
323
324 # Enter linux source dir
325 cd "${LINUX_SRCOBJ_DIR}"
326
327
328 # For RT kernels, copy version file
329 if [ -s localversion-rt ]; then
330 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
331 fi
332
333 # Copy all Makefile related stuff
334 find . -path './include/*' -prune \
335 -o -path './scripts/*' -prune -o -type f \
336 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
337 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
338 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
339
340 # Copy base scripts and include dirs
341 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 342
5a196804
MJ
343 # Copy arch includes
344 (find arch -name include -type d -print0 | \
345 xargs -0 -n1 -i: find : -type f) | \
346 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
347
348 # Copy arch scripts
349 (find arch -name scripts -type d -print0 | \
350 xargs -0 -n1 -i: find : -type f) | \
351 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
352
353 # Cleanup scripts
354 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
355 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
356
04873cc3 357 # On powerpc 32bits this object is required to link modules
5a196804 358 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
359 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
360 :
361 else
04873cc3
MJ
362 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
363 fi
5a196804
MJ
364 fi
365
366 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
367 if [ "${karch}" = "arm64" ]; then
368 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
369 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
370 fi
371 fi
372
373 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
374 if [ -f tools/objtool/objtool ]; then
375 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
376 fi
377
378 if [ -f "arch/x86/kernel/macros.s" ]; then
379 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
380 fi
381
382 # Copy modules related stuff, if available
383 if [ -s Module.symvers ]; then
384 cp Module.symvers "${LINUX_HDROBJ_DIR}"
385 fi
386
387 if [ -s System.map ]; then
388 cp System.map "${LINUX_HDROBJ_DIR}"
389 fi
390
391 if [ -s Module.markers ]; then
392 cp Module.markers "${LINUX_HDROBJ_DIR}"
393 fi
394
395 # Copy config file
396 cp .config "${LINUX_HDROBJ_DIR}"
397
398 # Make sure the Makefile and version.h have a matching timestamp so that
399 # external modules can be built
400 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
401 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
402 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
403 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
404 else
405 echo "Missing version.h"
406 exit 1
407 fi
408 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
409
410 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
780f6285
MJ
411 if [ ! -f "${LINUX_HDROBJ_DIR}/include/config/auto.conf" ]; then
412 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
413 fi
5a196804
MJ
414
415 # Finally clean the object files from the full source tree
416 make clean
417
418 # And regen the modules support files
419 make modules_prepare CC="$CC"
51fa2ab3 420
04873cc3 421 # On powerpc 32bits this object is required to link modules
d815b018 422 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
423 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
424 :
425 else
04873cc3
MJ
426 make arch/powerpc/lib/crtsavres.o CC="$CC"
427 fi
d815b018
MJ
428 fi
429
7a76a4d0 430 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 431 if [ "${karch}" = "arm64" ]; then
c236528e 432 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 433 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
434 fi
435 fi
436
7e02032c 437 # Version specific tasks
a1ae361e 438 case "$ktag" in
7e02032c
MJ
439 Ubuntu*)
440 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 441 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
442 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
443 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
444 ;;
445 esac
7e02032c
MJ
446}
447
448
339db64d
MJ
449build_modules() {
450
5a196804
MJ
451 local kdir="$1"
452 local outdir="$2"
453 local kversion
454
455 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 456
2456f978
MJ
457 # Try to catch some compatibility problems by turning some
458 # warnings into errors.
999a2aa0 459 #export KCFLAGS="$KCFLAGS -Wall -Werror"
2456f978 460
339db64d 461 # Enter lttng-modules source dir
5a196804 462 cd "${MODULES_GIT_DIR}"
339db64d
MJ
463
464 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
465 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
466 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
467 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
468
469 set +e
470
471 # Build modules
51fa2ab3 472 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 473 ret=$?
339db64d 474
5a196804
MJ
475 set -e
476
339db64d 477 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 478 if [ "$ret" -eq 0 ]; then
e9b44189 479 echo "This build should have failed."
339db64d
MJ
480 exit 1
481 fi
482
483 # We have to publish at least one file or the build will fail
5a196804 484 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 485
5a196804 486 KERNELDIR="${kdir}" make clean
7e02032c 487
339db64d
MJ
488 else # Regular build
489
490 # Build modules against full kernel sources
51fa2ab3 491 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
492
493 # Install modules to build dir
5a196804 494 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
495
496 # Clean build dir
5a196804 497 KERNELDIR="${kdir}" make clean
339db64d
MJ
498 fi
499}
500
501
502## MAIN ##
503
f3d8604b
MJ
504# Use all CPU cores
505NPROC=$(nproc)
506
5a196804
MJ
507MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
508LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 509
5a196804
MJ
510LINUX_OBJ_DIR="${WORKSPACE}/linux"
511LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
512LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
513LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 514
5a196804
MJ
515MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
516MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 517
5a196804
MJ
518LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
519
520OBJ_STORE_URL="s3://jenkins"
521
522cd "$WORKSPACE"
523
524# Create build directories
525mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
526
527git_clone_modules_sources
339db64d 528
7e02032c 529# Setup cross compile env if available
39961776 530if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
531
532 case "$cross_arch" in
533 "armhf")
534 karch="arm"
535 cross_compile="arm-linux-gnueabihf-"
53b51a15 536 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
537 ubuntu_config="armhf-config.flavour.generic"
538 ;;
539
540 "arm64")
541 karch="arm64"
542 cross_compile="aarch64-linux-gnu-"
53b51a15 543 vanilla_config="defconfig"
7e02032c
MJ
544 ubuntu_config="arm64-config.flavour.generic"
545 ;;
546
547 "powerpc")
548 karch="powerpc"
549 cross_compile="powerpc-linux-gnu-"
e9b44189 550 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
551 ubuntu_config="powerpc-config.flavour.powerpc-smp"
552 ;;
553
554 "ppc64el")
555 karch="powerpc"
556 cross_compile="powerpc64le-linux-gnu-"
e9b44189 557 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
558 ubuntu_config="ppc64el-config.flavour.generic"
559 ;;
560
561 *)
51fa2ab3 562 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
563 exit 1
564 ;;
565 esac
339db64d 566
7e02032c
MJ
567 # Export variables used by Kbuild for cross compilation
568 export ARCH="${karch}"
569 export CROSS_COMPILE="${cross_compile}"
339db64d 570
7e02032c 571# Set arch specific values if we are not cross compiling
39961776 572elif [ "x${arch}" != "x" ]; then
e9b44189 573
7e02032c 574 case "$arch" in
16844a6d 575 "i386")
7e02032c 576 karch="x86"
e9b44189 577 vanilla_config="allyesconfig"
7e02032c
MJ
578 ubuntu_config="i386-config.flavour.generic"
579 ;;
580
16844a6d 581 "amd64")
7e02032c 582 karch="x86"
e9b44189 583 vanilla_config="allyesconfig"
7e02032c
MJ
584 ubuntu_config="amd64-config.flavour.generic"
585 ;;
586
587 "armhf")
588 karch="arm"
e9b44189 589 vanilla_config="allyesconfig"
7e02032c
MJ
590 ubuntu_config="armhf-config.flavour.generic"
591 ;;
592
593 "arm64")
594 karch="arm64"
e9b44189 595 vanilla_config="allyesconfig"
7e02032c
MJ
596 ubuntu_config="arm64-config.flavour.generic"
597 ;;
598
599 "powerpc")
600 karch="powerpc"
e9b44189 601 vanilla_config="allyesconfig"
7e02032c
MJ
602 ubuntu_config="powerpc-config.flavour.powerpc-smp"
603 ;;
604
605 "ppc64el")
606 karch="powerpc"
e9b44189 607 vanilla_config="allyesconfig"
7e02032c
MJ
608 ubuntu_config="ppc64el-config.flavour.generic"
609 ;;
610
611 *)
612 echo "Unsupported arch $arch"
613 exit 1
614 ;;
615 esac
616else
04873cc3 617 echo "No arch or cross_arch specified"
7e02032c
MJ
618 exit 1
619fi
339db64d 620
339db64d 621
b214d997 622
5a196804
MJ
623# First get the kernel build from the object store, or build it, if it's
624# not available.
339db64d 625
5a196804
MJ
626echo "# Setup endpoint
627host_base = obj.internal.efficios.com
628host_bucket = obj.internal.efficios.com
629bucket_location = us-east-1
630use_https = True
7e02032c 631
5a196804
MJ
632# Setup access keys
633access_key = jenkins
634secret_key = echo123456
339db64d 635
5a196804
MJ
636# Enable S3 v4 signature APIs
637signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 638
c45b04df 639url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 640obj_name="linux.tar.bz2"
87445931
MJ
641
642if [ "x${cross_arch}" = "x" ]; then
643 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/native"
644else
645 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/${cross_arch}"
646fi
647
5a196804 648obj_url="$obj_url_prefix/$obj_name"
339db64d 649
5a196804 650set +e
e18b6e95
KS
651# In s3cmd 2.3, the return code of get when an object does not exist (64)
652# is different than in 2.2 (12). The return codes of 's3cmd info' are
653# consistent between 2.2 and 2.3.
654s3cmd -c "$WORKSPACE/.s3cfg" info "$obj_url"
5a196804
MJ
655ret=$?
656set -e
339db64d 657
5a196804
MJ
658case "$ret" in
659 "0")
e18b6e95 660 s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
5a196804
MJ
661 extract_archive_obj
662 ;;
a1ae361e 663
5a196804
MJ
664 "12")
665 echo "File not found"
339db64d 666
5a196804
MJ
667 # Build all the things and upload
668 # then finish the module build...
339db64d 669
5a196804
MJ
670 git_clone_linux_sources
671 git_export_linux_sources
339db64d 672
5a196804 673 select_compiler
a1ae361e 674
5a196804
MJ
675 ## PREPARE FULL LINUX SOURCE TREE
676 build_linux_kernel
d138fc44 677
5a196804
MJ
678 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
679 extract_distro_headers
339db64d 680
5a196804 681 tar_archive_obj
339db64d 682
5a196804 683 upload_archive_obj
339db64d 684
5a196804 685 ;;
339db64d 686
5a196804
MJ
687 *)
688 echo "Unknown error? Abort"
689 exit 1
690 ;;
691esac
339db64d 692
5a196804 693select_compiler
f3d8604b 694
7e02032c 695## BUILD modules
5a196804
MJ
696# Either we downloaded a pre-build kernel or we built it and uploaded
697# the archive for future builds.
698
699cd "$WORKSPACE"
f3d8604b 700
339db64d 701# Build modules against full kernel sources
5a196804 702build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 703
339db64d 704# Build modules against kernel headers
5a196804 705build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 706
5a196804
MJ
707# Make sure some modules were actually built
708tree "${MODULES_OUTPUT_KSRC_DIR}"
709if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
710 echo "No modules built!"
711 exit 1
712fi
713
5a196804
MJ
714tree "${MODULES_OUTPUT_KHDR_DIR}"
715if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
716 echo "No modules built!"
717 exit 1
718fi
b214d997 719
f3d8604b 720# EOF
This page took 0.063252 seconds and 4 git commands to generate.